Draft Layer

From FreeCAD Documentation
This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft Layer

Menu location
Utilities → Layer
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
0.19
See also
None

Description

The Draft Layer creates a special kind of group that controls the visual properties of objects placed inside of it. By changing the properties of the Layer, such as line width, line color, shape color and transparency, the changes are propagated to the objects that make use of the Layer property.

This tool replaces Draft VisGroup starting from FreeCAD 0.19.

Usage

  1. Go to the menu Draft → Utilities → Layer. This adds a new layer. If it is a the first layer, a Layers object will be created too, which contains all the layers.
  2. To add objects you can drag them into the layer. This will remove the objects from there original layer. If you want to have an object in several layers, e.g. to control the visibility of different sets of objects, you have to edit the Group property of the layer. Click the button occurring to the right and select/deselect the objects you want to have in or out of the layer.
  3. Change the desired view properties of the Layer.

Context menu options

The following options are available in the Tree view context menu:

For layer containers

  • Merge layer duplicates: this option currently does not work.
  • Add new layer: adds a new layer to the current document. This option is an alternative for this command.

For layers

Notes

Properties

See also: Property editor.

A Draft Layer object is derived from an App FeaturePython object and inherits all its properties. It also has the following additional properties:

Data

Layer

  • DataGroup (LinkList): specifies the objects that are inside the layer.

View

Layer

The properties in this section are applied to objects that are put inside the layer. And any changes to these properties are propagated to them. For two properties, ViewLine Color and ViewShape Color, this behavior is optional.

  • ViewDraw Style (Enumeration): specifies the draw style of the layer: Solid, Dashed, Dotted or Dashdot
  • ViewLine Color (Color): specifies the line color of the layer.
  • ViewLine Width (Float): specifies the line width of the layer.
  • ViewOverride Line Color Children (Bool): specifies if changes to the ViewLine Color of the layer are propagated to the objects inside the layer.
  • ViewOverride Shape Color Children (Bool): specifies if changes to the ViewShape Color of the layer are propagated to the objects inside the layer.
  • ViewShape Color (Color): specifies the shape color of the layer.
  • ViewTransparency (Percent): specifies the transparency of the layer.

Print

  • ViewLine Print Color (Color): specifies the line print color of the layer.
  • ViewUse Print Color (Bool): specifies if the ViewLine Print Color of the layer is used when the objects inside the layer are placed on a TechDraw page.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a layer use the make_layer method of the Draft module. To add objects to, or remove objects from, a layer change its Group property.

import FreeCAD as App
import Draft

doc = App.newDocument()

layer = Draft.make_layer()
lay_vobj = layer.ViewObject
lay_vobj.LineColor  = (1.0, 0.0, 0.0, 0.0) # red
lay_vobj.ShapeColor = (1.0, 1.0, 0.0, 0.0) # yellow

polygon1 = Draft.make_polygon(5, radius=1000)
polygon2 = Draft.make_polygon(3, radius=500)
polygon3 = Draft.make_polygon(6, radius=220)
layer.Group = [polygon1, polygon2, polygon3]

doc.recompute()